@if (buttonType === customButtonType.link && externalUrl) {
  <ng-container *ngTemplateOutlet="externalLinkTemplate"></ng-container>
} @else if (buttonType === customButtonType.link) {
  <ng-container *ngTemplateOutlet="linkTemplate"></ng-container>
} @else {
  <ng-container *ngTemplateOutlet="buttonTemplate"></ng-container>
}

<ng-template #buttonTemplate>
  <button
    (click)="buttonClick.emit()"
    [ngClass]="{
      'button-inherit': colorScheme === customButtonColorScheme.inherit,
      'button-main': colorScheme === customButtonColorScheme.main,
    }"
    class="custom-button"
    type="button"
  >
    <lib-custom-button-content
      [startIcon]="startIcon"
      [title]="title"
    ></lib-custom-button-content>
  </button>
</ng-template>

<ng-template #linkTemplate>
  <a
    [ngClass]="getButtonClasses()"
    [replaceUrl]="replaceUrl"
    [routerDirection]="'forward'"
    [routerLink]="routerLink"
    class="custom-button"
  >
    <lib-custom-button-content
      [startIcon]="startIcon"
      [title]="title"
    ></lib-custom-button-content>
  </a>
</ng-template>

<ng-template #externalLinkTemplate>
  <a
    [href]="externalUrl"
    [ngClass]="getButtonClasses()"
    class="custom-button"
    rel="noopener noreferrer"
    target="_blank"
  >
    <lib-custom-button-content
      [startIcon]="startIcon"
      [title]="title"
    ></lib-custom-button-content>
  </a>
</ng-template>
